`ctf` plugin: Use CTF_SCOPE_PACKET_UNKNOWN in place of -1
[babeltrace.git] / tests / utils / utils.sh
CommitLineData
644e0364
MJ
1#!/bin/bash
2
3# Copyright (c) 2019 Michael Jeanson <mjeanson@efficios.com>
4# Copyright (C) 2019 Philippe Proulx <pproulx@efficios.com>
5#
6# This program is free software; you can redistribute it and/or modify
7# it under the terms of the GNU General Public License as published by
8# the Free Software Foundation; under version 2 of the License.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License along
16# with this program; if not, write to the Free Software Foundation, Inc.,
17# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
18
19# This file is meant to be sourced at the start of shell script-based tests.
20
21
22# Error out when encountering an undefined variable
23set -u
24
9c5dd55a
MJ
25# If "readlink -f" is available, get a resolved absolute path to the
26# tests source dir, otherwise make do with a relative path.
644e0364 27scriptdir="$(dirname "${BASH_SOURCE[0]}")"
9c5dd55a
MJ
28if readlink -f "." >/dev/null 2>&1; then
29 testsdir=$(readlink -f "$scriptdir/..")
30else
31 testsdir="$scriptdir/.."
32fi
644e0364 33
5058d31b
JR
34# The OS on which we are running. See [1] for possible values of 'uname -s'.
35# We do a bit of translation to ease our life down the road for comparison.
36# Export it so that called executables can use it.
37# [1] https://en.wikipedia.org/wiki/Uname#Examples
38if [ "x${BT_OS_TYPE:-}" = "x" ]; then
39 BT_OS_TYPE="$(uname -s)"
40 case "$BT_OS_TYPE" in
41 MINGW*)
42 BT_OS_TYPE="mingw"
43 ;;
44 Darwin)
45 BT_OS_TYPE="darwin"
46 ;;
47 Linux)
48 BT_OS_TYPE="linux"
49 ;;
df9db467
JR
50 CYGWIN*)
51 BT_OS_TYPE="cygwin"
52 ;;
5058d31b
JR
53 *)
54 BT_OS_TYPE="unsupported"
55 ;;
56 esac
57fi
58export BT_OS_TYPE
59
644e0364
MJ
60# Allow overriding the source and build directories
61if [ "x${BT_TESTS_SRCDIR:-}" = "x" ]; then
9c5dd55a 62 BT_TESTS_SRCDIR="$testsdir"
644e0364
MJ
63fi
64export BT_TESTS_SRCDIR
65
66if [ "x${BT_TESTS_BUILDDIR:-}" = "x" ]; then
9c5dd55a 67 BT_TESTS_BUILDDIR="$testsdir"
644e0364
MJ
68fi
69export BT_TESTS_BUILDDIR
70
71# By default, it will not source tap.sh. If you to tap output directly from
72# the test script, define the 'SH_TAP' variable to '1' before sourcing this
73# script.
74if [ "x${SH_TAP:-}" = x1 ]; then
1d970e04 75 # shellcheck source=./tap/tap.sh
644e0364
MJ
76 . "${BT_TESTS_SRCDIR}/utils/tap/tap.sh"
77fi
78
79# Allow overriding the babeltrace2 executables
80if [ "x${BT_TESTS_BT2_BIN:-}" = "x" ]; then
4881a20e 81 BT_TESTS_BT2_BIN="$BT_TESTS_BUILDDIR/../src/cli/babeltrace2"
5058d31b 82 if [ "$BT_OS_TYPE" = "mingw" ]; then
27e2c58d
JR
83 BT_TESTS_BT2_BIN="${BT_TESTS_BT2_BIN}.exe"
84 fi
644e0364
MJ
85fi
86export BT_TESTS_BT2_BIN
87
88if [ "x${BT_TESTS_BT2LOG_BIN:-}" = "x" ]; then
4881a20e 89 BT_TESTS_BT2LOG_BIN="$BT_TESTS_BUILDDIR/../src/cli/babeltrace2-log"
5058d31b 90 if [ "$BT_OS_TYPE" = "mingw" ]; then
27e2c58d
JR
91 BT_TESTS_BT2LOG_BIN="${BT_TESTS_BT2LOG_BIN}.exe"
92 fi
644e0364
MJ
93fi
94export BT_TESTS_BT2LOG_BIN
95
96# TODO: Remove when bindings/python/bt2/test_plugin.py is fixed
97BT_PLUGINS_PATH="${BT_TESTS_BUILDDIR}/../src/plugins"
98
99# Allow overriding the babeltrace2 plugin path
100if [ "x${BT_TESTS_BABELTRACE_PLUGIN_PATH:-}" = "x" ]; then
101 BT_TESTS_BABELTRACE_PLUGIN_PATH="${BT_PLUGINS_PATH}/ctf:${BT_PLUGINS_PATH}/utils:${BT_PLUGINS_PATH}/text"
102fi
103
b14c7bf1
MJ
104if [ "x${BT_TESTS_PROVIDER_DIR:-}" = "x" ]; then
105 BT_TESTS_PROVIDER_DIR="${BT_TESTS_BUILDDIR}/../src/python-plugin-provider/.libs"
106fi
107
644e0364
MJ
108# Allow overriding the babeltrace2 executables
109if [ "x${BT_TESTS_PYTHONPATH:-}" = "x" ]; then
110 BT_TESTS_PYTHONPATH="${BT_TESTS_BUILDDIR}/../src/bindings/python/bt2/build/build_lib"
111fi
112
113
114### External Tools ###
115if [ "x${BT_TESTS_AWK_BIN:-}" = "x" ]; then
116 BT_TESTS_AWK_BIN="awk"
117fi
118export BT_TESTS_AWK_BIN
119
120if [ "x${BT_TESTS_GREP_BIN:-}" = "x" ]; then
121 BT_TESTS_GREP_BIN="grep"
122fi
123export BT_TESTS_GREP_BIN
124
125if [ "x${BT_TESTS_PYTHON_BIN:-}" = "x" ]; then
126 BT_TESTS_PYTHON_BIN="python3"
127fi
128export BT_TESTS_PYTHON_BIN
129
e23e08c4
MJ
130if [ "x${BT_TESTS_PYTHON_CONFIG_BIN:-}" = "x" ]; then
131 BT_TESTS_PYTHON_CONFIG_BIN="python3-config"
132fi
133export BT_TESTS_PYTHON_BIN
134
644e0364
MJ
135if [ "x${BT_TESTS_SED_BIN:-}" = "x" ]; then
136 BT_TESTS_SED_BIN="sed"
137fi
138export BT_TESTS_SED_BIN
139
140
141# Data files path
142BT_TESTS_DATADIR="${BT_TESTS_SRCDIR}/data"
143BT_CTF_TRACES_PATH="${BT_TESTS_DATADIR}/ctf-traces"
644e0364
MJ
144
145
146### Diff Functions ###
147
58db335e
FD
148# Checks the difference between:
149#
150# 1. What the CLI outputs on its standard output when given the arguments
151# "$@" (excluding the first two arguments).
152# 2. The file with path "$1".
153#
154# And the difference between:
155#
156# 1. What the CLI outputs on its standard error when given the arguments
157# "$@" (excluding the first two arguments).
158# 2. The file with path "$2".
644e0364
MJ
159#
160# Returns 0 if there's no difference, and 1 if there is, also printing
161# said difference to the standard error.
162bt_diff_cli() {
58db335e
FD
163 local expected_stdout_file="$1"
164 local expected_stderr_file="$2"
165 shift 2
53cc240b
MJ
166 local args=("$@")
167
58db335e
FD
168 local temp_stdout_output_file
169 local temp_stderr_output_file
644e0364
MJ
170 local temp_diff
171 local ret=0
172
58db335e
FD
173 temp_stdout_output_file="$(mktemp)"
174 temp_stderr_output_file="$(mktemp)"
644e0364
MJ
175 temp_diff="$(mktemp)"
176
58db335e
FD
177 # Run the CLI to get a detailed file.
178 run_python_bt2 "$BT_TESTS_BT2_BIN" "${args[@]}" 1>"$temp_stdout_output_file" 2>"$temp_stderr_output_file"
179
180 # Strip any \r present due to Windows (\n -> \r\n).
181 # "diff --string-trailing-cr" is not used since it is not present on
182 # Solaris.
183 "$BT_TESTS_SED_BIN" -i 's/\r//g' "$temp_stdout_output_file"
184 "$BT_TESTS_SED_BIN" -i 's/\r//g' "$temp_stderr_output_file"
185
186 # Compare stdout output with expected stdout output
187 if ! diff -u "$temp_stdout_output_file" "$expected_stdout_file" 2>/dev/null >"$temp_diff"; then
188 echo "ERROR: for '${args[*]}': actual standard output and expected output differ:" >&2
189 cat "$temp_diff" >&2
190 ret=1
191 fi
644e0364 192
58db335e
FD
193 # Compare stderr output with expected stderr output
194 if ! diff -u "$temp_stderr_output_file" "$expected_stderr_file" 2>/dev/null >"$temp_diff"; then
195 echo "ERROR: for '${args[*]}': actual standard error and expected error differ:" >&2
644e0364
MJ
196 cat "$temp_diff" >&2
197 ret=1
198 fi
199
58db335e 200 rm -f "$temp_stdout_output_file" "$temp_stderr_output_file" "$temp_diff"
644e0364
MJ
201
202 return $ret
203}
204
53cc240b
MJ
205# Checks the difference between the content of the file with path "$1"
206# and the output of the CLI when called on the directory path "$2" with
207# the arguments '-c sink.text.details' and the rest of the arguments to
208# this function.
644e0364
MJ
209#
210# Returns 0 if there's no difference, and 1 if there is, also printing
211# said difference to the standard error.
212bt_diff_details_ctf_single() {
58db335e 213 local expected_stdout_file="$1"
53cc240b
MJ
214 local trace_dir="$2"
215 shift 2
216 local extra_details_args=("$@")
58db335e 217 expected_stderr_file="/dev/null"
644e0364
MJ
218
219 # Compare using the CLI with `sink.text.details`
58db335e 220 bt_diff_cli "$expected_stdout_file" "$expected_stderr_file" "$trace_dir" "-c" "sink.text.details" "${extra_details_args[@]}"
644e0364
MJ
221}
222
223# Calls bt_diff_details_ctf_single(), except that "$1" is the path to a
224# program which generates the CTF trace to compare to. The program "$1"
225# receives the path to a temporary, empty directory where to write the
226# CTF trace as its first argument.
227bt_diff_details_ctf_gen_single() {
228 local ctf_gen_prog_path="$1"
58db335e 229 local expected_stdout_file="$2"
53cc240b
MJ
230 shift 2
231 local extra_details_args=("$@")
644e0364
MJ
232
233 local temp_trace_dir
234 local ret
235
236 temp_trace_dir="$(mktemp -d)"
237
238 # Run the CTF trace generator program to get a CTF trace
239 if ! "$ctf_gen_prog_path" "$temp_trace_dir" 2>/dev/null; then
240 echo "ERROR: \"$ctf_gen_prog_path\" \"$temp_trace_dir\" failed" >&2
241 rm -rf "$temp_trace_dir"
242 return 1
243 fi
244
245 # Compare using the CLI with `sink.text.details`
58db335e 246 bt_diff_details_ctf_single "$expected_stdout_file" "$temp_trace_dir" "${extra_details_args[@]}"
644e0364
MJ
247 ret=$?
248 rm -rf "$temp_trace_dir"
249 return $ret
250}
251
252
253### Functions ###
254
255check_coverage() {
256 coverage run "$@"
257}
258
259# Execute a shell command in the appropriate environment to have access to the
260# bt2 Python bindings.
261run_python_bt2() {
e23e08c4
MJ
262 local env_args
263
264 env_args=(
265 "BABELTRACE_PYTHON_BT2_NO_TRACEBACK=1" \
266 "BABELTRACE_PLUGIN_PATH=${BT_TESTS_BABELTRACE_PLUGIN_PATH}" \
267 "LIBBABELTRACE2_PLUGIN_PROVIDER_DIR=${BT_TESTS_PROVIDER_DIR}" \
268 "BT_CTF_TRACES_PATH=${BT_CTF_TRACES_PATH}" \
269 "BT_PLUGINS_PATH=${BT_PLUGINS_PATH}" \
270 "PYTHONPATH=${BT_TESTS_PYTHONPATH}:${BT_TESTS_SRCDIR}/utils/python"
271 )
644e0364 272
0408934a
SM
273 local main_lib_path="${BT_TESTS_BUILDDIR}/../src/lib/.libs"
274
644e0364 275 # Set the library search path so the python interpreter can load libbabeltrace2
df9db467 276 if [ "$BT_OS_TYPE" = "mingw" ] || [ "$BT_OS_TYPE" = "cygwin" ]; then
e23e08c4 277 env_args+=("PATH=${main_lib_path}:${PATH:-}")
5058d31b 278 elif [ "$BT_OS_TYPE" = "darwin" ]; then
e23e08c4 279 env_args+=("DYLD_LIBRARY_PATH=${main_lib_path}:${DYLD_LIBRARY_PATH:-}")
644e0364 280 else
e23e08c4
MJ
281 env_args+=("LD_LIBRARY_PATH=${main_lib_path}:${LD_LIBRARY_PATH:-}")
282 fi
283
284 # On Windows, an embedded Python interpreter needs a way to locate the path
285 # to it's internal modules, set the prefix from python-config to the
286 # PYTHONHOME variable.
287 if [ "$BT_OS_TYPE" = "mingw" ]; then
288 env_args+=("PYTHONHOME=$($BT_TESTS_PYTHON_CONFIG_BIN --prefix)")
644e0364
MJ
289 fi
290
e23e08c4 291 env "${env_args[@]}" "$@"
644e0364
MJ
292}
293
294# Set the environment and run python tests in the directory.
295#
296# $1 : The directory containing the python test scripts
297# $2 : The pattern to match python test script names (optional)
644e0364
MJ
298run_python_bt2_test() {
299 local test_dir="$1"
a818a617 300 local test_pattern="${2:-'*'}" # optional, if none default to "*"
644e0364
MJ
301
302 local ret
303 local test_runner_args=()
304
305 test_runner_args+=("$test_dir")
306 if [ "x${test_pattern}" != "x" ]; then
307 test_runner_args+=("${test_pattern}")
308 fi
309
310 if test "x${BT_TESTS_COVERAGE:-}" = "x1"; then
311 python_exec="check_coverage"
312 else
313 python_exec="${BT_TESTS_PYTHON_BIN}"
314 fi
315
316 run_python_bt2 \
317 "${python_exec}" \
318 "${BT_TESTS_SRCDIR}/utils/python/testrunner.py" \
a818a617
FD
319 --pattern "$test_pattern" \
320 "$test_dir" \
321
644e0364
MJ
322 ret=$?
323
324 if test "x${BT_TESTS_COVERAGE_REPORT:-}" = "x1"; then
325 coverage report -m
326 fi
327
328 if test "x${BT_TESTS_COVERAGE_HTML:-}" = "x1"; then
329 coverage html
330 fi
331
332 return $ret
333}
This page took 0.039475 seconds and 4 git commands to generate.